#include "morfofun.hh"

#include <cctype>
using std::toupper;

bool Is_K(char c) { if(c=='b'||c=='B' || c=='c'||c=='C'
                    || c=='d'||c=='D' || c=='f'||c=='F'
                    || c=='g'||c=='G' || c=='h'||c=='H'
                    || c=='j'||c=='J' || c=='k'||c=='K'
                    || c=='l'||c=='L' || c=='m'||c=='M'
                    || c=='n'||c=='N' || c=='p'||c=='P'
                    || c=='q'||c=='Q' || c=='r'||c=='R'
                    || c=='s'||c=='S' || c=='t'||c=='T'
                    || c=='v'||c=='V' || c=='w'||c=='W'
                    || c=='x'||c=='X' || c=='z'||c=='Z')return true;
                    return false; }
bool Is_L(char c) { if(c=='b'||c=='B' || c=='c'||c=='C'
                    || c=='d'||c=='D' || c=='f'||c=='F'
                    || c=='g'||c=='G' || c=='h'||c=='H'
                    || c=='j'||c=='J' || c=='l'||c=='L'
                    || c=='m'||c=='M' || c=='n'||c=='N'
                    || c=='q'||c=='Q' || c=='r'||c=='R'
                    || c=='s'||c=='S' || c=='v'||c=='V'
                    || c=='w'||c=='W' || c=='x'||c=='X'
                    || c=='z'||c=='Z')return true;
                    return false; }
bool Is_P(char c) { if(c=='k'||c=='K'
                    || c=='p'||c=='P'
                    || c=='t'||c=='T')return true;
                    return false; }
bool Is_V(char c) { if(c=='a'||c=='A' || c=='e'||c=='E'
                    || c=='i'||c=='I' || c=='o'||c=='O'
                    || c=='u'||c=='u' || c=='y'||c=='Y'
                    || c==''||c=='' || c==''||c=='')return true;
                    return false; }
bool equal(char c, char c2)
{
	if(c==''||c=='')c='a';
	else if(c==''||c=='')c='o';
	else if(c=='y'||c=='Y')c='u';
	if(c2==''||c2=='')c2='a';
	else if(c2==''||c2=='')c2='o';
	else if(c2=='y'||c2=='Y')c2='u';
	return toupper(c)==toupper(c2);
}

/* Returns true if mask matches word. */
bool Match(const string &word, const string &mask)
{
	unsigned m = mask.size();
	unsigned w = word.size();
	char K=0, P=0, L=0, V=0;
	while(m > 0)
	{
		--m;
		if(mask[m]=='*') { w = 0; break; }
		--w;
		if(mask[m]=='K') { if(!K) { if(!Is_K(word[w]))return false; K=word[w]; } else if(K!=word[w]) return false; continue; }
		if(mask[m]=='P') { if(!P) { if(!Is_P(word[w]))return false; P=word[w]; } else if(P!=word[w]) return false; continue; }
		if(mask[m]=='L') { if(!L) { if(!Is_L(word[w]))return false; L=word[w]; } else if(L!=word[w]) return false; continue; }
		if(mask[m]=='V') { if(!V) { if(!Is_V(word[w]))return false; V=word[w]; } else if(V!=word[w]) return false; continue; }
		if(!equal(word[w], mask[m]))return false;
	}
	return !w;
}

/* Replaces mask from word with pat. */
const string Replace(const string &word, const string &mask, const string &pat)
{
	unsigned m = mask.size();
	unsigned w = word.size();
	char K=0, P=0, L=0, V=0;
	bool yla = true;
	while(m > 0)
	{
		--m;
		if(mask[m]=='*')break;
		--w;
		if(mask[m]=='K') { K=word[w]; continue; }
		if(mask[m]=='P') { P=word[w]; continue; }
		if(mask[m]=='L') { L=word[w]; continue; }
		if(mask[m]=='V') { V=word[w]; continue; }
	}
	char O = yla ? 'u' : 'o';
	for(unsigned a=word.size(); a>0; )
	{
		--a;
		if(word[a]=='o' || word[a]=='O'
		|| word[a]=='' || word[a]=='') { O = 'o'; break; }
		if(word[a]=='u' || word[a]=='y'
		|| word[a]=='U' || word[a]=='Y') { O = 'u'; break; }
	}
	for(unsigned a=word.size(); a>0; )
	{
		--a;
		if(word[a]=='a' || word[a]=='o' || word[a]=='u'
		|| word[a]=='A' || word[a]=='O' || word[a]=='U') { yla = false; break; }
	}		
	string res;
	for(m=0; m<pat.size(); ++m)
	{
		char c = pat[m];
		if(c=='O')c = O;
		if(c=='*') res += word.substr(0, w);
		else if(c=='K') res += K;
		else if(c=='P') res += P;
		else if(c=='L') res += L;
		else if(c=='V') res += V;
		else if(yla)
		{
			if(c=='a')res += '';
			else if(c=='o')res += '';
			else if(c=='u')res += 'y';
			else res += c;
		}
		else
			res += c;
	}
	return res;
}

void Trim(string &s)
{
	unsigned b = 0;
	unsigned a = s.size();
	for(; a; ++b)
	{
		--a;
		if(s[a]!='\r' && s[a]!=' ' && s[a]!='\n')break;
	}
	if(b) { s.erase(s.size()-b); b=0; }
	for(; b<s.size() && (s[b]==' ' || s[b]=='\t'); ++b);
	if(b)s.erase(0, b);
}

using std::fgets;

int Struktit_Apu::Get(FILE *fp)
{
	string s2 = s; Trim(s2);
#if 0
	fprintf(stderr, "Get: s='%s', state=%d, hdr='%s', mask='%s'\n",
		s2.c_str(), state,
		hdr.c_str(),
		mask.c_str());
#endif
	for(;;)
	{
    	switch(state)
    	{
    		case 6:
    			hdr.erase();
    			mask.erase();
    			tab.clear();
    			state = 0;
    			/* passthru */
    		case 0:
    		case 3:
    		{
    			char Buf[4096];
    			if(!fgets(Buf, sizeof(Buf), fp))
    			{
    				state = 5;
    				if(tab.size())return 0;
    				return -1;
    			}
    			s = Buf;
    			++state; /* 0->1, 3->4 */
    			break;
    		}
    		case 1: /* Expect [*] */
    		{
        		if(!s.size() || s[0] != '[')
        		{
        			state = 0;
        			break;
        		}
        		
       			unsigned haka = s.find(']');
       			if(haka == s.npos) { state = 0; break; }
       			
       			mask = s.substr(1, haka - 1);
       			state = 2;
       			if(tab.size())return 0;
       			/* passthru */
       		}
       		case 2: /* Have mask */
       		{
       			state = 3;
       			return 1;
       		}
    		case 5: return -1;
       		case 4: /* Expect hdr */
       		{
       			if(s.size() && s[0]=='[') { state=1; break; }
        		unsigned commpos = s.find("//");
        		if(commpos != s.npos)
        			s.erase(commpos);
        		unsigned colonpos = s.find(':');
        		if(colonpos != s.npos)
        		{
        			state = 7 + colonpos;
        			if(tab.size())return 0;
        		}
        		/* passthru */
        	}
        	default:
        	{
        		if(state >= 7)
        		{
	        		unsigned colonpos = state-7;
       				hdr = s.substr(0, colonpos);
        			s.erase(0, colonpos+1);
        			tab.clear();
        		}
        		Trim(s);
        		unsigned a = 0;
        		for(;;)
        		{
        			unsigned b = s.find(' ', a);
        			if(b == s.npos)b = s.find('\t', a);
        			if(b == s.npos)b = s.size();
        			if(b > a)
        			{
        				const string stmp = s.substr(a, b-a);
#if 0
        				fprintf(stderr, "Pushing for %s.%s: %s\n", mask.c_str(), hdr.c_str(), stmp.c_str());
#endif
        				tab.push_back(stmp);
        			}
        			if(b == s.size())break;
        			a = b+1;
        		}
        		state = 3;
        	}
    	}
	}
}
